local freeslotsframe = CreateFrame("Frame", "FreeBagSpacesFrameThing", UIParent)
freeslotsframe:SetSize(16, 16) -- WxH
freeslotsframe:SetPoint("CENTER")
freeslotsframe:SetClampedToScreen(true)
freeslotsframe:EnableMouse(true)
freeslotsframe:SetMovable(true)
freeslotsframe:RegisterForDrag("LeftButton")
freeslotsframe:SetScript("OnDragStart", function(self) self:StartMoving() end)
freeslotsframe:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
freeslotsframe:SetUserPlaced(true)
freeslotsframe:Show()
local bg = freeslotsframe:CreateTexture()
bg:SetAllPoints(freeslotsframe)
bg:SetColorTexture(0, 0, 0, 0.5)

local freeslots = freeslotsframe:CreateFontString(nil, nil, "GameFontHighlight")
freeslots:SetPoint("TOPLEFT", 16, -16)
--freeslots:SetText("Free Bag Spaces: " .. tonumber(totalFreeSlots))

local TotalFreeSlotsFrame = CreateFrame("Frame")
TotalFreeSlotsFrame:RegisterEvent("BAG_UPDATE_DELAYED")
TotalFreeSlotsFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

local function eventHandler(self, event, ...)

if event == "BAG_UPDATE_DELAYED" or event == "PLAYER_ENTERING_WORLD" then

numberOfFreeSlotsBagZero, BagTypeZero = GetContainerNumFreeSlots(0)
numberOfFreeSlotsBagOne, BagTypeOne = GetContainerNumFreeSlots(1)
numberOfFreeSlotsBagTwo, BagTypeTwo = GetContainerNumFreeSlots(2)
numberOfFreeSlotsBagThree, BagTypeThree = GetContainerNumFreeSlots(3)
numberOfFreeSlotsBagFour, BagTypeFour = GetContainerNumFreeSlots(4)

local totalFreeSlots = numberOfFreeSlotsBagZero + numberOfFreeSlotsBagOne + numberOfFreeSlotsBagTwo + numberOfFreeSlotsBagThree + numberOfFreeSlotsBagFour
freeslots:SetText("Free Bag Spaces: " .. tonumber(totalFreeSlots))

end

end

TotalFreeSlotsFrame:SetScript("OnEvent", eventHandler)